'******************************************************************************
' CD4.BAS = Routinen z. Suchen, Sortieren, Einfuegen u.Loeschen v.Feldelementen
' =======
' Dieses Q(uick)asic-Programm realisiert eine kleine Datenbank fuer Audio-CDs.
' Gleichzeitig domonstriert das Programm wie man Feldelemente suchen, sortieren,
' einfuegen und loeschen kann.
'
' (c) Hans-georg Schuhmann, aus "Das grosse QBasic 1.1 Buch"
'*******************************************************************************
 '
 'Vereinbarungen---------------------------------------
  DECLARE SUB eingeben (CD$())
  DECLARE SUB ausgeben (CD$())
  DECLARE SUB suchen (CD$())
  DECLARE SUB loeschen (CD$())
  DECLARE SUB entfernen (CD$(), Alt$)
  DECLARE SUB einfuegen (CD$(), Neu$)
  DECLARE FUNCTION Gefunden% (CD$(), Such$)
  DECLARE FUNCTION Luecke% (CD$(), Such$)
  DECLARE SUB warten ()
  CONST CDMax% = 100
  DIM CD$(1 TO CDMax%)
  DIM SHARED Ein%, Taste$
 '
 'VerwaltungsMen--------------------------------------
  CLS
  DO
    PRINT
    PRINT "Was nun:  1. Eingeben  2. Anzeigen  ";
    INPUT "3. Suchen  4. Lschen  0. Ende  ", Wahl%
    SELECT CASE Wahl%
      CASE 1
        eingeben CD$()
      CASE 2
        ausgeben CD$()
      CASE 3
        suchen CD$()
      CASE 4
        loeschen CD$()
    END SELECT
  LOOP UNTIL Wahl% = 0
END

'
SUB ausgeben (CD$())
  CLS
  DO
    Aus% = Aus% + 1
    PRINT CD$(Aus%)
    warten
  LOOP UNTIL (Aus% >= Ein%) OR (Taste$ = CHR$(27))
END SUB

'
SUB einfuegen (CD$(), Neu$)
  IF Ein% < CDMax% THEN
    Stelle% = Luecke%(CD$(), (Neu$))
    Ein% = Ein% + 1
    FOR i% = Ein% TO Stelle% + 1 STEP -1
      CD$(i%) = CD$(i% - 1)
    NEXT i%
    CD$(Stelle%) = Neu$
  END IF
END SUB

'
SUB eingeben (CD$())
  DO WHILE (Ein% < CDMax%) AND (Taste$ <> CHR$(27))
    LINE INPUT "CD-Titel: ", Eingabe$
    einfuegen CD$(), (Eingabe$)
    warten
  LOOP
END SUB

'
SUB entfernen (CD$(), Alt$)
  Stelle% = Gefunden%(CD$(), (Alt$))
  IF Stelle% > -1 THEN
    FOR i% = Stelle% TO Ein% - 1
      CD$(i%) = CD$(i% + 1)
    NEXT i%
    CD$(Ein%) = ""
    Ein% = Ein% - 1
  END IF
END SUB

'
FUNCTION Gefunden% (CD$(), Such$)
  Von% = 1
  Bis% = Ein%
  DO WHILE Von% <= Bis%
    Mitte% = (Von% + Bis%) \ 2
    IF Such$ = CD$(Mitte%) THEN
      Gefunden% = Mitte%
      EXIT FUNCTION
    END IF
    IF Such$ > CD$(Mitte%) THEN
      Von% = Mitte% + 1
    ELSE
      Bis% = Mitte% - 1
    END IF
  LOOP
  Gefunden% = -1
END FUNCTION

'
SUB loeschen (CD$())
  LINE INPUT "CD-Titel: ", Loesch$
  entfernen CD$(), (Loesch$)
END SUB

'
FUNCTION Luecke% (CD$(), Such$)
  Von% = 1
  Bis% = Ein%
  DO WHILE Von% <= Bis%
    Mitte% = (Von% + Bis%) \ 2
    IF Such$ > CD$(Mitte%) THEN
      Von% = Mitte% + 1
    ELSE
      Bis% = Mitte% - 1
    END IF
  LOOP
  Luecke% = Von%
END FUNCTION

'
SUB suchen (CD$())
  LINE INPUT "Gesucht: ", Such$
  Stelle% = Gefunden%(CD$(), (Such$))
  IF Stelle% > -1 THEN
    PRINT "Gefunden: CD Nr."; Stelle%
  ELSE
    PRINT "CD nicht gefunden!"
  END IF
END SUB

'
SUB warten
  PRINT "Weiter mit Taste (ESC=Ende)!"
  DO
    Taste$ = INKEY$
  LOOP WHILE Taste$ = ""
END SUB

