'****************************************************************************
'
' FILE-FLD.BAS - Demo zur Bearbeitung von Random-Files ber FIELD-Puffer
' ============
' Bearbeitung einer Telefon-Datenbank: Ein Name (Textstring) und eine Telefon-
' nummer werden zunchst in einen FIELD-Puffer eingetragen und dann von dort
' in den dritten Datensatz der Datenbank-Datei "Telefon.tmp" transferiert.
'
' Anschlieend wird der Datensatz aus der Datei wieder in den FIELD-Puffer
' eingelesen und auf dem Bildschirm angezeigt.
'
' Die Telefonnummer ist ein numerischer Wert und mu daher vor dem Eintrag in
' den FIELD-Puffer durch MKL$ in einen Pseudostring no$ umgewandelt und nach
' dem Rcklesen wieder durch CVL rckgewandelt werden.
'
' Wenn Sie Lust haben, knnen Sie sich die resultierende Datei "telefon.tmp"
' im Stammverzeichnis des Lufwerks C:\ anschauen. Dabei werden Sie
' feststellen, dass die Telefonnummer dort nicht als String, sondern als
' nurmale numerische Gre abgelegt wird. Bitte lschen Sie die Datei
' von Hand, nachdem Sie das Programm ausprobiert haben.
'
'
'   \         (c) Thomas Antoni, 01.8.99 - 3.11.02
'    \ /\           Mailto:thomas@antonis.de
'    ( )            http://www.antonis.de 
'  .( o ).
'              ----==== Hottest QBasic Stuff on Earth !!! ====----
'
'****************************************************************************

CLS
'---------- Datensatz in Datei schreiben -----
OPEN "c:\telefon.tmp" FOR RANDOM AS #1 LEN = 20 'Telefon-Datenbank
FIELD #1, 12 AS name$, 8 AS no$  'FIELD-Puffer fr 1 Datensatz deklarieren
                                 'mit 12 Bytes fr den Namen und 8 Bytes fr
                                 'die Telefonnummer
LSET name$ = "Antoni"            'Namen in Field eintragen
LSET no$ = MKL$(23852)           'Telefonnummer (TYP LONG Integer) in
                                 'String wandeln u.in FIELD eintragen
PUT #1, 3                        'Inhalt des FIELD-Puffers in den 3. Daten-
                                 'satz der Datei transferieren
CLOSE #1

'------------ Datensatz aus Datei lesen --------
OPEN "c:\telefon.tmp" FOR RANDOM AS #1 LEN = 20
                                 'wie oben, ffnen zum Lesen ffnen
FIELD #1, 12 AS name$, 8 AS no$  'wie oben
GET #1, 3
PRINT name$, "Telefon-Nr."; CVL(no$)
                                 'Inhalt des FIELD-Puffers lesen und anzeigen
                                 '(numerischen Pseudostring vorher rckwan-
                                 'deln)
CLOSE #1

SLEEP
END

